entity MAX6816 is
	port
	(
		clk	 : in bit;
		key_in : in bit;
		key_out: out bit
	);
	
end MAX6816;

architecture rtl of MAX6816 is
	-- Funcao auxiliar para incrementar o contador
	function "+" (a, b: bit_vector) return bit_vector is
		variable s : bit_vector(a'range) := (others => '0');
		variable cin : bit := '0';
	begin
		abc: for i in a'reverse_range loop
			s(i) := a(i) xor b(i) xor cin;
			cin := (a(i) and b(i)) or (cin and (a(i) or b(i)));
		end loop abc;
		return s;
	end function "+";

	signal counter_reset, counter_clk, counter_q, dff_d, dff_q : bit;

begin

	dff_d <= not key_in;
	key_out <= 	not dff_q;
	
	counter_reset <= dff_d xnor dff_q;
	
	dff: process(counter_q)
	begin
		if (counter_q'event and counter_q = '1') then
			dff_q <= dff_d;
		end if;
	end process;
	
	counter : work.counter
		generic map
		(
			WIDTH => 5
		)
		port map
		(
			clk	 => counter_clk,
			clr	 => counter_reset,
			--q	 => ReadData_std,
			cout => counter_q
		);
	
--	counter: process(counter_clk, counter_reset)
--		constant zero : bit_vector(4 downto 0) := (others => '0');
--		constant um : bit_vector(4 downto 0) := (0 => '1', others => '0');
--		variable count : bit_vector(4 downto 0) := (others => '0');
--	begin
--		if (counter_reset = '1') then
--			count := zero;
--		elsif (counter_clk'event and counter_clk = '1') then
--			count := count + um;
--		end if;
--		counter_q <= count(count'high);
--	end process;

	clk_divider : work.counter
		generic map
		(
			WIDTH => 15
		)
		port map
		(
			clk	 => clk,
			clr	 => '0',
			--q	 => ReadData_std,
			cout => counter_clk
		);
	
--	clk_divider: process(clk)
--		constant zero : bit_vector(14 downto 0) := (others => '0');
--		constant um : bit_vector(14 downto 0) := (0 => '1', others => '0');
--		variable count : bit_vector(14 downto 0) := (others => '0');
--	begin
--		if (clk'event and clk = '1') then
--			count := count + um;
--		end if;
--		counter_clk <= count(count'high);
--	end process;

end rtl;
