package RV16Cm_pkg is

	-- Component Declaration
	
	component ALU is
		generic
		(
			WIDTH : integer := 4
		);
		port
		(
			A, B		: in  bit_vector(WIDTH-1 downto 0);
			ALUControl	: in  bit_vector(2 downto 0);

			Result		: out bit_vector(WIDTH-1 downto 0);
			Zero		: out bit
		);
	end component;

	component RegBank is
		generic
		(
			WIDTH : integer := 4;
			SIZE: integer := 2
		);
		port
		(
			CLK, WE3		: in  bit;
			A1, A2, A3	: in  bit_vector(SIZE-1 downto 0);
			WD3		: in  bit_vector(WIDTH-1 downto 0);

			RD1, RD2	: out bit_vector(WIDTH-1 downto 0)
		);
	end component;

	component FSM is
		port
		(
			clk			: in  bit;
			reset			: in  bit;
			Zero			: in  bit;
			Op				: in  bit_vector(1 downto 0);
			Funct3		: in  bit_vector(2 downto 0);

			PCWrite		: out  bit;
			AdrSrc		: out  bit;
			MemWrite		: out  bit;
			IRWrite		: out  bit;
			RegWrite		: out  bit;
			ResultSrc	: out  bit_vector(1 downto 0);
			ALUControl	: out  bit_vector(2 downto 0);
			ALUSrcA		: out  bit_vector(1 downto 0);
			ALUSrcB		: out  bit_vector(1 downto 0);
			ImmSrc		: out  bit_vector(1 downto 0)
		);
	end component;

end RV16Cm_pkg;
